1000 ' --------------------- FILE-DOS --------------------------
1010 '
1020 '            Olivetti M24 personal computer
1030 '
1040 ' --------     PCOS M20 > MS DOS converter    -------------
1050 '
1060 '      Legge il file  PCOS.DAT e lo converte in files DOS.
1070 '
1080 '      I files sono chiamati con nomi convezionali a causa
1090 '      della diversa struttura del PCOS.
1100 '      Il file PCOS.DIR contiene una directoy DOS-like del
1110 '      contenuto nel disco e le equivalenze dei nomi usati
1120 '
1130 '              Rel 1.0 del 12 nov. 1986
1140 '
1150 ' ---------------------------------------------------------
1160 '
1170 DEFINT I-S
1180                   ' DIRECTORY         FILE DESCRIPTOR BLOCK
1190 DIM NOMI$(288,3)  ' Nome del file =1  password del file=2  equivalenza=3
1200 DIM FDB(112,81)   ' puntatore FDB =1  lunghezza =2/3 nr. extent =4  flag =5
1210                   '                   6-8-10...80 first data block pointer
1220                   '                   7-9-11...81 lunghezza dell'extent
1230 '
1240 DIM NOMEFILE$(14),FDBLOCK$(14),DATADDR$(38),NRBLOCK$(38)
1250 '
1260 ' Apre il file che contiene una copia del disco PCOS
1270 OPEN "R", #1, "PCOS.DAT",256
1280 '
1290 ' Apre il file della directory DOS-like
1300 OPEN "O", #2, "PCOS.DIR"
1310 '
1320 ' Definisce il formato del Volume Descriptor Block
1330 FIELD #1,14 AS VOLNAME$,14 AS PASSWORD$,28 AS FLAG$,200 AS U$
1340 FIELD #1,56 AS U$,136 AS BITMAP$,60 AS UNUSED$
1350 '
1360 GET #1,1       ' Legge il settore del VDB
1370 '
1380 A$=VOLNAME$ : GOSUB 6000 : PRINT #2, "Volume name is: ";A$;
1390 A$=PASSWORD$ : GOSUB 6000: PRINT #2, A$
1400 PRINT
1410 '
1420 ' Trascura le informazioni contenute nei FLAG e nella BIT MAP
1430 '
1440 ' Definisce il formato della DIRECTORY
1450 FOR I=1 TO 14
1460   FIELD #1,(I-1)*18 AS U$,14 AS NOMEFILE$(I),4 AS FDBLOCK$(I)
1470 NEXT I
1480 FIELD #1,252 AS U$,4 AS UNUSED$
1490 '
1500 ' Per semplificazione si assume che il nr. massimo di files sia 112
1510 ' anziche' i 288 che puo' contenere la traccia della directory
1520 '
1530 ' Legge la directory (track 16 - head 0)
1540 '
1550 NRFILES=0
1560 FOR SECTOR = 3 TO 10  ' Nota: solo 8 settori anziche' 14
1570   FOR I=1 TO 14
1580     GET #1,SECTOR     ' Nota: nell'ordine dei blocchi track posta = 0
1590     K=ASC(NOMEFILE$(I))
1600     IF NOMEFILE$(I)=STRING$(14,CHR$(255)) THEN I=14:SECTOR=16 : GOTO 1650
1610     IF K=255 THEN MID$(NOMEFILE$(I),1,1)="@" 'Legge anche i file cancellati
1620     N=(SECTOR-3)*14+I  : NRFILES=NRFILES+1
1630     A$=NOMEFILE$(I) : GOSUB 6000 : NOMI$(N,1)=A$
1640     A$=FDBLOCK$(I) : GOSUB 4000 : FDB(N,1)=VAL(A$)
1650   NEXT I
1660 NEXT SECTOR
1670 IF NRFILES=0 THEN PRINT #2,"Nessun file presente"
1680 '
1690 ' Definisce il formato del FILE DESCRIPTOR BLOCK
1700 FIELD #1, 4 AS LFILE$,2 AS EXTENT$,14 AS PASSWORD$,4 AS FLAG$
1710 FOR I=1 TO 38
1720   FIELD #1,(I-1)*6+24 AS U$,4 AS DATADDR$(I),2 AS NRBLOCK$(I)
1730 NEXT I
1740 '
1750 ' Procede nella lettura dei dati relarivi ai files
1760 '
1770 FOR I=1 TO NRFILES
1780   '
1790   GET #1,FDB(I,1)+1       ' Legge il FDB di ogni file
1800   '
1810   A$=LEFT$(LFILE$,2) : GOSUB 4090 : FDB(I,2)=VAL(A$) ' Lenght * 65536
1820   A$=LFILE$  : GOSUB 4000 : FDB(I,3)=VAL(A$)         ' Lenght mod 65536
1830   A$=EXTENT$ : GOSUB 4090 : FDB(I,4)=VAL(A$)         ' Nr. di extents
1840   A$=FLAG$                                           ' Trascura i Flags
1850   A$=PASSWORD$ : GOSUB 6000 : NOMI$(I,2)=A$          ' Password del file
1860   '
1870   ' Legge tutti gli extent
1880   '
1890   FOR J=1 TO FDB(I,4)
1900     M=2*(J-1)+5
1910     A$=DATADDR$(J) : GOSUB 4000 : FDB(I,M)=VAL(A$)   ' Indirizzo dati
1920     A$=NRBLOCK$(J) : GOSUB 4090 : FDB(I,M+1)=VAL(A$) ' Nr. blocchi dati
1930   NEXT J
1940   '
1950   ' Analizza i nomi dei files per compatibilita` DOS
1960   ' Tronca i nomi a 8 chr. e converte le minuscole in maiuscole
1970   '
1980   A$= NOMI$(I,1) : J=INSTR(A$,".")
1990   IF J=0 THEN NOMI$(I,3)=LEFT$(A$,8)             : GOTO 2050
2000   IF J>9 THEN NOMI$(I,3)=LEFT$(A$,8)+MID$(A$,J,4): GOTO 2050
2010   NOMI$(I,3)=LEFT$(A$,J-1)+MID$(A$,J,4)
2020   '
2030   ' Elimina le lettere minuscole
2040   '
2050   FOR L=1 TO LEN(NOMI$(I,3))
2060     K=ASC(MID$(NOMI$(I,3),L,1))
2070     IF K>96 AND K<123 THEN K=K-32
2080     MID$(NOMI$(I,3),L,1)=CHR$(K)
2090   NEXT L
2100   '
2110   ' Scrive il file PCOS.DIR
2120   '
2130   PRINT #2, NOMI$(I,3),NOMI$(I,1);NOMI$(I,2);
2140   PRINT #2, USING " ######";FDB(I,2)*65356!+FDB(I,3);
2150   PRINT #2, USING  "  ####";FDB(I,4),FDB(I,1),FDB(I,5),FDB(I,6)
2160   '
2170 NEXT I
2180 '
2190 CLOSE #2
2200 '
2210 ' Scrive i files DOS
2220 '
2230 ' Definizione contenuto settori
2240 FIELD #1,128 AS ALFA$,128 AS BETA$
2250 '
2260 FOR I=1 TO NRFILES
2270   '
2280   PRINT : PRINT NOMI$(I,1)
2290   '
2300   OPEN "O", #2, NOMI$(I,3)
2310   '
2320   FOR J=1 TO FDB(I,4)
2330     K=5+(J-1)*2
2340     FOR L=1 TO FDB(I,K+1)
2345       N=0 : PRINT ".";
2350       '
2360       GET #1,FDB(I,K)+L    ' Legge un blocco logico
2370       '
2380       IF L=FDB(I,K+1) THEN N=FDB(I,3)-INT(FDB(I,3)/256)*256 ELSE 2410
2390       IF N=0 THEN 2410
2400       IF N>128 THEN B$=MID$(BETA$,1,N) : A$=ALFA$ : GOTO 2420
2405       A$=MID$(ALFA$,1,N) : B$="" : GOTO 2420
2410       A$=ALFA$  : B$=BETA$
2420       PRINT #2, A$;B$; : GOTO 2450
2421       '  FOR P=1 TO LEN(A$)
2422       '    S=ASC(MID$(A$,P,1)) AND &H7f : IF S<32 THEN S=46
2423       '    PRINT CHR$(S);
2424       '  NEXT
2426       '  FOR R=1 TO LEN(B$)
2427       '    S=ASC(MID$(B$,R,1)) AND &H7F : IF S<32 THEN S=46
2428       '    PRINT CHR$(S);
2429       '  NEXT
2440       '
2450     NEXT L
2460   NEXT J
2470   '
2480   CLOSE #2
2490   '
2500 NEXT I
2510 END
2520 '
4000     ' ----------  Subroutine conversione stringa 4 chr. in intero
4010     '
4020     ' Nota: primo chr.= piu' signifcativo
4030     ' La conversione viene effettuata solo
4040     ' sui due caratteri meno significativi
4050     '
4060     A$=STR$( ASC(MID$(A$,3,1))*256 + ASC(MID$(A$,4,1)))
4070     '
4080     RETURN
4090     '
5000     ' ----------   Subroutine conversione stringa 2 chr. in intero
5010     ' Nota: primo chr.= piu' signifcativo
5020     '
5030     A$=STR$( ASC(MID$(A$,1,1))*256 + ASC(MID$(A$,2,1)))
5040     '
5050     RETURN
5060     '
6000     ' ----------   Subroutine conversione caratteri
6010     '
6020     FOR A=1 TO LEN(A$)
6030       IF MID$(A$,A,1)=CHR$(0) THEN MID$(A$,A,1)=" "
6040     NEXT
6050     RETURN
