100 ' -------------------- PCOSFILE ---------------------------
110 '
120 '            Olivetti M24 personal computer
130 '
140 ' --------     PCOS M20 > MS DOS converter    -------------
150 '
160 '      Legge un disco PCOS e lo visualizza in ASCII
170 '
180 '              Rel 1.0 del 9 nov. 1986
190 '
200 ' ---------------------------------------------------------
210 '
220 CLEAR ,&HD000   ' Libera 12 Kbytes di memoria
230 DEFINT I,J,K,L,M,N,O,S
240 '
250 ' Fase 1: modifica tabella parametri disco con quella del PCOS
260 DATA cf,02,50,1,10,20,ff,32,f6,0f,02
270 '
280 ' Fase 2: scrive in memoria un programma in L.M. 8086
290 DATA ba,00,00,b9,00,00,b8,00,fc,8b,d8,b8,01,02,cd,13,cb
300 '
310 ' Fase 3: ripristina i parametri originali del DOS 3.10
320 DATA cf,02,25,02,09,2a,ff,50,f6,01,04
330 '
340 DEF SEG = &H0           ' Indirizzo empirico
350 ADR     = &H522         ' tabella parametri disco
360 '
370 PRINT "Tabella dati in RAM "
380 FOR I=0 TO 10
390  PRINT RIGHT$("0"+HEX$(PEEK(ADR+I)),2);" ";
400 NEXT
410 PRINT
420 '
430 PRINT "Premi un tasto per continuare ..."
440 IF INKEY$="" THEN 440
450 '
460 OPEN "PCOS.DAT" FOR OUTPUT AS #1
470 '
480 ' Scrive in memoria i nuovi dati
490 FOR I=0 TO 10
500  READ A$
510  POKE (ADR+I),VAL("&H"+A$)
520 NEXT
530 '
540 DEF SEG                ' Ora il segmento e' quello del BASIC
550 '
560 ' Scrive il programma Assembler all'indirizzo &hF000
570 ' Il buffer di lettura e' posto a &hfc00
580 '
590 OFC = &HF000   ' Origin of code
600 SOFS = &HFC00 ' start of sector
610 '
620 '
630 FOR I=0 TO 16
640  READ A$
650  POKE (OFC+I),VAL("&H"+A$)
660 NEXT
670 '
680 '
690 DRV = OFC+1   ' drive
700 OH  = OFC+2   ' head
710 OS  = OFC+4   ' sector
720 OT  = OFC+5   ' track
730 '
740 POKE (DRV),0  ' La lettura del disco avviene sul drive A
750 '
760 ' Lettura directory del dischetto PCOS
770 '
780 TRACK = 16
790 HEAD = 0
800 '
810 POKE (OT),TRACK
820 POKE (OH),HEAD
830 '
840 FOR SECTOR = 1 TO 16
850   '
860   ' FOR I=OFC TO OFC+16 : PRINT HEX$(PEEK(I))" "; : NEXT : PRINT
870   '
880   POKE (OS),SECTOR
890   GOSUB 1240    ' Legge un settore
900   '
910 NEXT SECTOR
920 '
930 PRINT "Premi un tasto per continuare ..."
940 IF INKEY$="" THEN 940
950 '
960 ' Legge il contenuto del disco ( blocchi logici 16 - 1087 del PCOS )
970 '
980 FOR TRACK = 0 TO 34
990   FOR HEAD = 0 TO 1
1000     FOR SECTOR = 1 TO 16
1010     '
1020     POKE (OT),TRACK
1030     IF (TRACK=0 OR TRACK=16) AND HEAD=0 THEN HEAD=1
1040     POKE (OH),HEAD
1050     POKE (OS),SECTOR
1060     '
1070     ' FOR I=OFC TO OFC+16 : PRINT HEX$(PEEK(I))" "; : NEXT : PRINT
1080     '
1090     GOSUB 1240    ' Legge un settore
1100     '
1110     NEXT SECTOR
1120   NEXT HEAD
1130 NEXT TRACK
1140 '
1150 DEF SEG = &H0           ' Indirizzo empirico
1160 ADR     = &H522         ' tabella parametri disco
1170 '
1180 ' Ritrascrive i parametri del DOS 3.10
1190 FOR I=0 TO 10
1200  READ A$
1210  POKE (ADR+I),VAL("&H"+A$)
1220 NEXT
1230 END
1240     ' Subrutine lettura settore disco
1250     '
1260     CALL OFC      ' Legge un settore
1270     '
1280     PRINT "track" TRACK "head" HEAD "sector" SECTOR
1290     '
1300     FOR I=0 TO 255
1310         PRINT #1,CHR$(PEEK(SOFS+I));
1320     NEXT I
1330     RETURN
