100 ' --------------------- PCOSREAD --------------------------
110 '
120 '            Olivetti M24 personal computer
130 '
140 ' --------     PCOS M20 > MS DOS converter    -------------
150 '
160 '      Legge un disco PCOS e visualizza in HEX + ASCII
170 '
180 '              Rel 1.0 del 9 nov. 1986
190 '
200 ' ---------------------------------------------------------
210 '
220 CLEAR ,&HD000   ' Libera 12 Kbytes di memoria
230 DEFINT I,J,K,L,M,N,O,S
240 '
250 ' Fase 1: modifica tabella parametri disco con quelli PCOS
260 DATA cf,02,50,1,10,20,ff,32,f6,0f,02
270 '
280 ' Fase 2: scrive in memoria un programma in L.M.8086
290 DATA ba,00,00,b9,00,00,b8,00,fc,8b,d8,b8,01,02,cd,13,cb
300 '
310 ' Fase 3: ripristina i parametri originali del DOS 3.10
320 DATA cf,02,25,02,09,2a,ff,50,f6,01,04
330 '
340 DEF SEG = &H0           ' Indirizzo empirico
350 ADR     = &H522         ' tabella parametri disco
360 '
370 PRINT "Tabella dati in RAM "
380 FOR I=0 TO 10
390  PRINT RIGHT$("0"+HEX$(PEEK(ADR+I)),2);" ";
400 NEXT
410 PRINT
420 '
430 PRINT "Premi un tasto per continuare ..."
440 IF INKEY$="" THEN 440
450 '
460 ' Scrive in memoria i nuovi dati
470 FOR I=0 TO 10
480  READ A$
490  POKE (ADR+I),VAL("&H"+A$)
500 NEXT
510 '
520 DEF SEG                ' Ora il segmento e' quello del BASIC
530 '
540 ' Scrive il programma Assembler all'indirizzo &hF000
550 ' Il buffer di lettura e' posto a &hfc00
560 '
570 OFC = &HF000   ' Origin of code
580 SOFS = &HFC00 ' start of sector
590 '
600 '
610 FOR I=0 TO 16
620  READ A$
630  POKE (OFC+I),VAL("&H"+A$)
640 NEXT
650 '
660 '
670 DRV = OFC+1   ' drive
680 OH  = OFC+2   ' head
690 OS  = OFC+4   ' sector
700 OT  = OFC+5   ' track
710 '
720 POKE (DRV),0  ' La lettura del disco avviene sul drive A
730 '
740 ' Lettura directory del dischetto PCOS
750 '
760 TRACK = 16
770 HEAD = 0
780 '
790 POKE (OT),TRACK
800 POKE (OH),HEAD
810 '
820 FOR SECTOR = 1 TO 16
830   '
840   ' FOR I=OFC TO OFC+16 : PRINT HEX$(PEEK(I))" "; : NEXT : PRINT
850   '
860   POKE (OS),SECTOR
870   GOSUB 1220    ' Legge un settore
880   '
890 NEXT SECTOR
900 '
910 PRINT "Premi un tasto per continuare ..."
920 IF INKEY$="" THEN 920
930 '
940 ' Legge il contenuto del disco ( blocchi logici 16 - 1113 del PCOS )
950 '
960 FOR TRACK = 0 TO 34
970   FOR HEAD = 0 TO 1
980     FOR SECTOR = 1 TO 16
990     '
1000     POKE (OT),TRACK
1010     IF (TRACK=0 OR TRACK=16) AND HEAD=0 THEN HEAD=1
1020     POKE (OH),HEAD
1030     POKE (OS),SECTOR
1040     '
1050     ' FOR I=OFC TO OFC+16 : PRINT HEX$(PEEK(I))" "; : NEXT : PRINT
1060     '
1070     GOSUB 1220    ' Legge un settore
1080     '
1090     NEXT SECTOR
1100   NEXT HEAD
1110 NEXT TRACK
1120 '
1130 DEF SEG = &H0           ' Indirizzo empirico
1140 ADR     = &H522         ' tabella parametri disco
1150 '
1160 ' Ripristina i parametri disco del DOS 3.10
1170 FOR I=0 TO 10
1180  READ A$
1190  POKE (ADR+I),VAL("&H"+A$)
1200 NEXT
1210 END
1220     ' Subrutine lettura settore disco e visualizzazione
1230     '
1240     CALL OFC      ' Legge un settore
1250     '
1260     PRINT "track" TRACK "head" HEAD "sector" SECTOR
1270     '
1280     ' Visualizza i dati della directory in HEX + ASCII
1290     '
1300     IF TRACK<>16 OR HEAD=1 THEN L=16 : GOTO 1340
1310     '
1320     IF SECTOR=1 OR SECTOR=2 THEN L=14 ELSE L=18
1330     '
1340     FOR I=0 TO 255 STEP L
1350       A$=""
1360       FOR J=0 TO L-1
1370         IF I+J > 255 THEN PRINT "   "; : GOTO 1430
1380         K=PEEK(SOFS+I+J)
1390         PRINT RIGHT$("0"+HEX$(K),2) " ";
1400         K=K AND &H7F
1410         IF K<32 THEN K=46
1420         A$=A$+CHR$(K)
1430       NEXT J
1440       A$=A$+SPACE$(L)
1450       PRINT LEFT$(A$,L)
1460     NEXT I
1470     RETURN
